"use strict";

const Promise = require("bluebird");
const mapObj = require("map-obj");

const nixLocate = require("./nix-locate");
const selectBestPackage = require("./select-best-package");

module.exports = function findPackages(libraries) {
	return Promise.try(() => {
		return nixLocate(libraries);
	}).then((groupedResults) => {
		return mapObj(groupedResults, (library, results) => {
			return [ library, selectBestPackage(library, results).attribute ];
		});
	});
};
