"use strict";

const Promise = require("bluebird");
const nanoid = require("nanoid");

const runProgram = require("./run-program");

module.exports = function nixBuild(file) {
	return Promise.try(() => {
		let outLink = `/tmp/depfish-build-${nanoid()}`;
		
		return Promise.try(() => {
			return runProgram("nix", [
				"build",
				"--file", file,
				"--out-link", outLink
			]);
		}).then(() => {
			return outLink;
		});
	});
};
